
#include <stdio.h>
#include <string.h>
#include <badpenguin-fs.h>
#include "device-manager.h"
#include "device-info.h"

int check_scsi_module(char *module) {
  char tempstr[256];
  strcpy(tempstr, PROC_DIR);
  strcat(tempstr, "/");
  strcat(tempstr, module );
  strcat(tempstr, "/0");
  if ( 0 == file_exists(tempstr) ) {
    printf("scanpci: module %s already supported by the kernel.\n", module);
    return 0;
  } else { 
    if (giVerbose>0) printf("scanpci: module %s need to be loaded.\n", module);
    return -1;
  }
}

int detect_scsi_devices(TChain *pcichain) {
  TPciDevice *pcidata = NULL;
  TChainItem *pciitem = NULL;
  int         devfound= 0;
  int         modfound= 0;  

  pciitem = pcichain->head;
  while (pciitem!=NULL) {
    // get PCI data
    pcidata = pciitem->data;
    // Check Device
    if ((pcidata->class==PCI_CLASS_STORAGE) && (pcidata->subclass==PCI_CLASS_STORAGE_SCSI)) {
      // Found scsi device
      devfound++;
      if (giVerbose>1) printf("SCSI Dev.: %4x.%4x  %i.%i \n", 
        pcidata->vendor, pcidata->device, pcidata->class, pcidata->subclass
      );
      // Get Device Info if available
      check_device_info(pcidata, SCSI_DETECTFILE);
      // if a driver is found try to see if it is already supported
      if (pcidata->genericModule > 1 ) {
        modfound = check_scsi_module(pcidata->kernelModule);
	// Need to load the module ?
	if (modfound!=0) {
	}
      }
    }
    // next
    pciitem = pciitem->next;
  }
  return 0;
}
